package org.eclipse.jdt.internal.compiler.batch;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import javax.tools.JavaFileManager;
import javax.tools.JavaFileObject;
import org.eclipse.jdt.core.compiler.CharOperation;
import org.eclipse.jdt.internal.compiler.batch.ClasspathLocation;
import org.eclipse.jdt.internal.compiler.batch.FileSystem;
import org.eclipse.jdt.internal.compiler.classfmt.ClassFormatException;
import org.eclipse.jdt.internal.compiler.env.NameEnvironmentAnswer;

public class ClasspathJsr199 extends ClasspathLocation {
  private static final Set<JavaFileObject.Kind> fileTypes = new HashSet<>();
  
  private JavaFileManager fileManager;
  
  private JavaFileManager.Location location;
  
  static {
    fileTypes.add(JavaFileObject.Kind.CLASS);
  }
  
  public ClasspathJsr199(JavaFileManager file, JavaFileManager.Location location) {
    super(null, null);
    this.fileManager = file;
    this.location = location;
  }
  
  public List fetchLinkedJars(FileSystem.ClasspathSectionProblemReporter problemReporter) {
    return null;
  }
  
  public NameEnvironmentAnswer findClass(char[] typeName, String qualifiedPackageName, String qualifiedBinaryFileName) {
    return findClass(typeName, qualifiedPackageName, qualifiedBinaryFileName, false);
  }
  
  public NameEnvironmentAnswer findClass(char[] typeName, String qualifiedPackageName, String aQualifiedBinaryFileName, boolean asBinaryOnly) {
    String qualifiedBinaryFileName = (File.separatorChar == '/') ? 
      aQualifiedBinaryFileName : 
      aQualifiedBinaryFileName.replace(File.separatorChar, '/');
    try {
      Exception exception2;
      int lastDot = qualifiedBinaryFileName.lastIndexOf('.');
      String className = (lastDot < 0) ? qualifiedBinaryFileName : qualifiedBinaryFileName.substring(0, lastDot);
      JavaFileObject jfo = null;
      try {
        jfo = this.fileManager.getJavaFileForInput(this.location, className, JavaFileObject.Kind.CLASS);
      } catch (IOException iOException) {}
      if (jfo == null)
        return null; 
      Exception exception1 = null;
    } catch (ClassFormatException classFormatException) {
    
    } catch (IOException iOException) {}
    return null;
  }
  
  public char[][][] findTypeNames(String aQualifiedPackageName) {
    String qualifiedPackageName = (File.separatorChar == '/') ? aQualifiedPackageName : aQualifiedPackageName.replace(
        File.separatorChar, '/');
    Iterable<JavaFileObject> files = null;
    try {
      files = this.fileManager.list(this.location, qualifiedPackageName, fileTypes, false);
    } catch (IOException iOException) {}
    if (files == null)
      return null; 
    ArrayList<char[][]> answers = new ArrayList();
    char[][] packageName = CharOperation.splitOn(File.separatorChar, qualifiedPackageName.toCharArray());
    for (JavaFileObject file : files) {
      String fileName = file.toUri().getPath();
      int last = fileName.lastIndexOf('/');
      if (last > 0) {
        int indexOfDot = fileName.lastIndexOf('.');
        if (indexOfDot != -1) {
          String typeName = fileName.substring(last + 1, indexOfDot);
          answers.add(CharOperation.arrayConcat(packageName, typeName.toCharArray()));
        } 
      } 
    } 
    int size = answers.size();
    if (size != 0) {
      char[][][] result = new char[size][][];
      answers.toArray(result);
      return result;
    } 
    return null;
  }
  
  public void initialize() throws IOException {}
  
  public boolean isPackage(String aQualifiedPackageName) {
    String qualifiedPackageName = (File.separatorChar == '/') ? aQualifiedPackageName : aQualifiedPackageName.replace(
        File.separatorChar, '/');
    boolean result = false;
    try {
      Iterable<JavaFileObject> files = this.fileManager.list(this.location, qualifiedPackageName, fileTypes, false);
      Iterator<JavaFileObject> f = files.iterator();
      if (f.hasNext()) {
        result = true;
      } else {
        files = this.fileManager.list(this.location, qualifiedPackageName, fileTypes, true);
        f = files.iterator();
        if (f.hasNext())
          result = true; 
      } 
    } catch (IOException iOException) {}
    return result;
  }
  
  public void reset() {
    try {
      this.fileManager.flush();
    } catch (IOException iOException) {}
  }
  
  public String toString() {
    return "Classpath for Jsr 199 JavaFileManager: " + this.location;
  }
  
  public char[] normalizedPath() {
    if (this.normalizedPath == null)
      this.normalizedPath = this.path.toCharArray(); 
    return this.normalizedPath;
  }
  
  public String getPath() {
    if (this.path == null)
      this.path = this.location.getName(); 
    return this.path;
  }
  
  public int getMode() {
    return 2;
  }
  
  public boolean hasAnnotationFileFor(String qualifiedTypeName) {
    return false;
  }
}
